<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: playerOfTheMatch.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: playerOfTheMatch.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * This module accept matches data and return an object with players who has won the highest number of Player of the Match awards for each season.
 * @module playerOfTheMatch
 */

/**
 *
 * @param {Array.&lt;Object>} matchesData parsed JSON data of matches.
 * @returns {Object} an object with players who has won the highest number of Player of the Match awards for each season.
 */

const playerOfTheMatch = (matchesData) => {
  if (!Array.isArray(matchesData)) return {};

  const playerOfTheMatch = matchesData.reduce((acc, match) => {
    if (acc[match.season] === undefined) {
      acc[match.season] = {};
    }

    if (acc[match.season][match.player_of_match] === undefined) {
      acc[match.season][match.player_of_match] = 0;
    }

    acc[match.season][match.player_of_match] += 1;

    return acc;
  }, {});

  Object.keys(playerOfTheMatch).forEach((season) => {
    const result = Object.entries(playerOfTheMatch[season])
      .sort((a, b) => a[1] - b[1])
      .pop();
    playerOfTheMatch[season] = {
      [result[0]]: result[1],
    };
  });

  return playerOfTheMatch;
};

module.exports = playerOfTheMatch;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">IPL Project</a></h2><h3>Modules</h3><ul><li><a href="module-bestSuperoverEconomy.html">bestSuperoverEconomy</a></li><li><a href="module-calcEconomy.html">calcEconomy</a></li><li><a href="module-config.html">config</a></li><li><a href="module-economicalBowlers.html">economicalBowlers</a></li><li><a href="module-extraRunsPerTeam.html">extraRunsPerTeam</a></li><li><a href="module-matchesInGivenYear.html">matchesInGivenYear</a></li><li><a href="module-matchesPerYear.html">matchesPerYear</a></li><li><a href="module-matchesWonPerTeam.html">matchesWonPerTeam</a></li><li><a href="module-matchesWonWithToss.html">matchesWonWithToss</a></li><li><a href="module-playerDismissed.html">playerDismissed</a></li><li><a href="module-playerOfTheMatch.html">playerOfTheMatch</a></li><li><a href="module-saveOutput.html">saveOutput</a></li><li><a href="module-strikeRate.html">strikeRate</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Wed May 26 2021 15:19:05 GMT+0530 (India Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
